// UsbFx2Driver.cpp: CUsbFx2Driver NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UsbFx2Driver.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


CUsbFx2Driver *CUsbFx2Driver::m_pThis = NULL;

CUsbFx2Driver::CUsbFx2Driver(IUsbFx2DriverHost *pHostClass, HWND hHostHwnd)
	: cusb2(hHostHwnd)
	, m_pDriverHost(pHostClass)
{
	m_pThis = this;
}

CUsbFx2Driver::~CUsbFx2Driver()
{
	CloseDriver();
}

const bool CUsbFx2Driver::OpenDriver(const BYTE byDeviceID, const BYTE *pFirmWare, const char *lpszFirmName)
{
	if(!pFirmWare)return false;

	// UN[Y
	CloseDriver();
	
	// t@[EFÃ_E[hs
	return fwload(byDeviceID, const_cast<BYTE *>(pFirmWare), (BYTE *)lpszFirmName);
}

void CUsbFx2Driver::CloseDriver(void)
{
	// SẴXbhI
	for(DWORD dwIndex = 0UL ; dwIndex < m_ThreadArray.size() ; dwIndex++){
		if(!m_ThreadArray[dwIndex].pThreadTcb->looping)continue;

		// XbhIVOiZbg
		m_ThreadArray[dwIndex].pThreadTcb->looping = false;

		// XbhI҂
		if(::WaitForSingleObject(m_ThreadArray[dwIndex].pThreadTcb->th, 1000UL) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_ThreadArray[dwIndex].pThreadTcb->th, 0UL);
			}

		::CloseHandle(m_ThreadArray[dwIndex].pThreadTcb->th);
		delete m_ThreadArray[dwIndex].pThreadTcb;
		}

	// ԂNA
	m_EndPointArray.clear();
	m_ThreadArray.clear();
}

const bool CUsbFx2Driver::AddEndPoint(const BYTE byAddress, DWORD *pdwEpIndex)
{
	// ̃AhX
	for(DWORD dwIndex = 0UL ; dwIndex < m_EndPointArray.size() ; dwIndex++){
		if(m_EndPointArray[dwIndex]->Address == byAddress)return false;	
		}

	// Gh|Cgǉ
	CCyUSBEndPoint *pEndPoint = get_endpoint(byAddress);
	if(!pEndPoint)return false;
	
	// Xgɓo^
	if(pdwEpIndex)*pdwEpIndex = m_EndPointArray.size();
	m_EndPointArray.push_back(pEndPoint);

	return true;		
}

const bool CUsbFx2Driver::TransmitData(const DWORD dwEpIndex, BYTE *pData, DWORD &dwLen)
{
	if(!pData || (dwEpIndex >= m_EndPointArray.size()))return false;

	// f[^]
	LONG lLen = dwLen;
	
	if(!xfer(m_EndPointArray[dwEpIndex], pData, lLen))return false;
	
	dwLen = (DWORD)lLen;
	
	return true;
}

const bool CUsbFx2Driver::CreateFifoThread(const BYTE byAddress, DWORD *pdwThreadIndex, const DWORD dwBufLen, const DWORD dwQueNum)
{
	// XbhN
	TAG_THREADINFO ThreadInfo;
	::ZeroMemory(&ThreadInfo, sizeof(ThreadInfo));

	ThreadInfo.pThreadTcb = new cusb2_tcb;
	if(!ThreadInfo.pThreadTcb)return false;
	
	ThreadInfo.pThreadTcb->epaddr = byAddress;
	ThreadInfo.pThreadTcb->ep = get_endpoint(byAddress);
	ThreadInfo.pThreadTcb->xfer = dwBufLen;
	ThreadInfo.pThreadTcb->ques = dwQueNum;
	ThreadInfo.pThreadTcb->cb_func = CUsbFx2Driver::FifoRecvCallback;

	ThreadInfo.pThreadTcb->th = ::CreateThread(NULL, 0UL, (LPTHREAD_START_ROUTINE)cusb2::thread_proc, (LPVOID)ThreadInfo.pThreadTcb, CREATE_SUSPENDED, &ThreadInfo.dwThreadID);
	if(!ThreadInfo.pThreadTcb->th)return false;

	// Xgɓo^
	if(pdwThreadIndex)*pdwThreadIndex = m_ThreadArray.size();
	m_ThreadArray.push_back(ThreadInfo);
	
	// W[
	::ResumeThread(ThreadInfo.pThreadTcb->th);
	
	return true;
}

bool CUsbFx2Driver::FifoRecvCallback(u8 *pData, u32 dwLen)
{
	// Ăяo肷邽߂ɃXbhID擾
	const DWORD dwThreadID = ::GetCurrentThreadId();
	
	for(DWORD dwIndex = 0UL ; dwIndex < m_pThis->m_ThreadArray.size() ; dwIndex++){
		if(m_pThis->m_ThreadArray[dwIndex].dwThreadID == dwThreadID){
			// C^tF[XĂяo
			return m_pThis->m_pDriverHost->OnRecvFifoData(dwIndex, pData, dwLen, m_pThis);
			}		
		}

	return false;
}
