// UsbFx2Driver.h: CUsbFx2Driver NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include <vector>
#include "cusb2.h"


using std::vector;


// ftHgFIFOobt@p[^ݒ
#define DEF_BUFLEN	(1024UL * 64UL)		// cap_sts
#define DEF_QUENUM	(16UL)				// cap_sts


/////////////////////////////////////////////////////////////////////////////
// FIFOf[^MC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

class CUsbFx2Driver;

class IUsbFx2DriverHost
{
friend CUsbFx2Driver;

protected:
	virtual const bool OnRecvFifoData(const DWORD dwThreadIndex, const BYTE *pData, const DWORD dwLen, CUsbFx2Driver *pDriver) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// cusb2 bp[NX
/////////////////////////////////////////////////////////////////////////////

class CUsbFx2Driver : private cusb2
{
public:
	CUsbFx2Driver(IUsbFx2DriverHost *pHostClass, HWND hHostHwnd = NULL);
	~CUsbFx2Driver();

	const bool OpenDriver(const BYTE byDeviceID, const BYTE *pFirmWare, const char *lpszFirmName = NULL);
	void CloseDriver(void);
	
	const bool AddEndPoint(const BYTE byAddress, DWORD *pdwEpIndex = NULL);
	const bool TransmitData(const DWORD dwEpIndex, BYTE *pData, DWORD &dwLen);
	const bool CreateFifoThread(const BYTE byAddress, DWORD *pdwThreadIndex = NULL, const DWORD dwBufLen = DEF_BUFLEN, const DWORD dwQueNum = DEF_QUENUM);
		
protected:
	static bool FifoRecvCallback(u8 *pData, u32 dwLen);

	struct TAG_THREADINFO
	{
		DWORD dwThreadID;
		cusb2_tcb *pThreadTcb;
	};

	static CUsbFx2Driver *m_pThis;

	IUsbFx2DriverHost *m_pDriverHost;
	
	vector<CCyUSBEndPoint *> m_EndPointArray;
	vector<TAG_THREADINFO> m_ThreadArray;
};
