// TsDescriptor.h: Lqqbp[NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsEncode.h"
#include "TsDescriptor.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// Lqq̊NX
/////////////////////////////////////////////////////////////////////////////

CBaseDesc::CBaseDesc()
{
	Reset();
}

CBaseDesc::CBaseDesc(const CBaseDesc &Operand)
{
	// Rs[RXgN^
	*this = Operand;
}

CBaseDesc & CBaseDesc::operator = (const CBaseDesc &Operand)
{
	// Zq
	m_byDescTag = Operand.m_byDescTag;
	m_byDescLen = Operand.m_byDescLen;
	m_bIsValid = Operand.m_bIsValid;

	return *this;
}

const bool CBaseDesc::ParseDesc(const BYTE *pHexData, const BYTE byDataLength)
{
	Reset();
	
	// ʃtH[}bg`FbN
	if(!pHexData)return false;									// f[^
	else if(byDataLength < (pHexData[1] + 2U))return false;		// f[^Lqq̃TCY

	m_byDescTag = pHexData[0];
	m_byDescLen = pHexData[1];

	// yC[h
	if(StoreContents(&pHexData[2])){
		m_bIsValid = true;
		}
	
	return m_bIsValid;
}

const bool CBaseDesc::IsValid(void) const
{
	// f[^L(͍)ǂԂ
	return m_bIsValid;
}

const BYTE CBaseDesc::GetTag(void) const
{
	// Lqq^OԂ
	return m_byDescTag;
}

const BYTE CBaseDesc::GetLen(void) const
{
	// LqqԂ
	return m_byDescLen;
}

void CBaseDesc::Reset(void)
{
	// ԂNA
	m_byDescTag = 0x00U;
	m_byDescLen = 0U;
	m_bIsValid = false;
}


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access LqqۉNX
/////////////////////////////////////////////////////////////////////////////

CCaMethodDesc::CCaMethodDesc()
	: CBaseDesc()
{
	Reset();
}

CCaMethodDesc::CCaMethodDesc(const CCaMethodDesc &Operand)
{
	*this = Operand;
}

CCaMethodDesc & CCaMethodDesc::operator = (const CCaMethodDesc &Operand)
{
	CBaseDesc::operator = (Operand);

	m_wCaMethodID = Operand.m_wCaMethodID;
	m_wCaPID = Operand.m_wCaPID;
	m_PrivateData = Operand.m_PrivateData;

	return *this;
}

void CCaMethodDesc::Reset(void)
{
	CBaseDesc::Reset();

	m_wCaMethodID = 0x0000U;		// Conditional Access Method ID
	m_wCaPID = 0xFFFFU;				// Conditional Access PID
}

const WORD CCaMethodDesc::GetCaMethodID(void) const
{
	// Conditional Access Method ID Ԃ
	return m_wCaMethodID;
}

const WORD CCaMethodDesc::GetCaPID(void) const
{
	// Conditional Access PID
	return m_wCaPID;
}

const CMediaData * CCaMethodDesc::GetPrivateData(void) const
{
	// Private Data Ԃ
	return &m_PrivateData;
}

const bool CCaMethodDesc::StoreContents(const BYTE *pPayload)
{
	// tH[}bg`FbN
	if(m_byDescTag != 0x09U)return false;								// ^Os
	else if(m_byDescLen < 4U)return false;								// CA\bhLqq̍ŏTCY4
	else if((pPayload[2] & 0xE0U) != 0xE0U)return false;				// Œrbgs

	// Lqq
	m_wCaMethodID = (WORD)pPayload[0] << 8 | (WORD)pPayload[1];			// +0,1	Conditional Access Method ID
	m_wCaPID = (WORD)(pPayload[2] & 0x1FU) << 8 | (WORD)pPayload[3];	// +2,3	Conditional Access PID
	m_PrivateData.SetData(&pPayload[4], m_byDescLen - 4U);				// +4-	Private Data

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// [0x48] Service LqqۉNX
/////////////////////////////////////////////////////////////////////////////

CServiceDesc::CServiceDesc()
	: CBaseDesc()
{
	Reset();
}

CServiceDesc::CServiceDesc(const CServiceDesc &Operand)
{
	*this = Operand;
}

CServiceDesc & CServiceDesc::operator = (const CServiceDesc &Operand)
{
	CBaseDesc::operator = (Operand);

	// CX^X̃Rs[
	m_byServiceType = Operand.m_byServiceType;
	::lstrcpy(m_szProviderName, Operand.m_szProviderName);
	::lstrcpy(m_szServiceName, Operand.m_szServiceName);

	return *this;
}

void CServiceDesc::Reset(void)
{
	CBaseDesc::Reset();
	
	m_byServiceType = 0x00U;			// Service Type
	m_szProviderName[0] = TEXT('\0');	// Service Provider Name
	m_szServiceName[0] = TEXT('\0');	// Service Name
}

const BYTE CServiceDesc::GetServiceType(void) const
{
	// Service TypeԂ
	return m_byServiceType;
}

const DWORD CServiceDesc::GetProviderName(LPTSTR lpszDst) const
{
	// Service Provider NameԂ
	if(lpszDst)::lstrcpy(lpszDst, m_szProviderName);

	return ::lstrlen(m_szProviderName);
}

const DWORD CServiceDesc::GetServiceName(LPTSTR lpszDst) const
{
	// Service Provider NameԂ
	if(lpszDst)::lstrcpy(lpszDst, m_szServiceName);

	return ::lstrlen(m_szServiceName);
}

const bool CServiceDesc::StoreContents(const BYTE *pPayload)
{
	// tH[}bg`FbN
	if(m_byDescTag != 0x48U)return false;		// ^Os
	else if(m_byDescLen < 3U)return false;		// T[rXLqq̃TCY͍Œ3

	// Lqq
	m_byServiceType = pPayload[0];				// +0	Service Type
	
	BYTE byPos = 1U;
	
	// Provider Name
	if(pPayload[byPos + 0]){
		CAribString::AribToString(m_szProviderName, &pPayload[byPos + 1], pPayload[byPos + 0]);
		byPos += pPayload[byPos + 0];
		}
	
	byPos++;

	// Service Name
	if(pPayload[byPos + 0]){
		CAribString::AribToString(m_szServiceName, &pPayload[byPos + 1], pPayload[byPos + 0]);
		byPos += pPayload[byPos + 0];
		}

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqۉNX
/////////////////////////////////////////////////////////////////////////////

CStreamIdDesc::CStreamIdDesc()
	: CBaseDesc()
{
	Reset();
}

CStreamIdDesc::CStreamIdDesc(const CStreamIdDesc &Operand)
{
	*this = Operand;
}

CStreamIdDesc & CStreamIdDesc::operator = (const CStreamIdDesc &Operand)
{
	CBaseDesc::operator = (Operand);

	m_byComponentTag = Operand.m_byComponentTag;

	return *this;
}

void CStreamIdDesc::Reset(void)
{
	CBaseDesc::Reset();

	m_byComponentTag = 0x00U;	// Component Tag
}

const BYTE CStreamIdDesc::GetComponentTag(void) const
{
	// Component Tag Ԃ
	return m_byComponentTag;
}

const bool CStreamIdDesc::StoreContents(const BYTE *pPayload)
{
	// tH[}bg`FbN
	if(m_byDescTag != 0x52U)return false;		// ^Os
	else if(m_byDescLen != 1U)return false;		// Xg[IDLqq̃TCY͏1

	// Lqq
	m_byComponentTag = pPayload[0];				// +0	Component Tag

	return true;
}


